#ifndef __MAPPATH_H_
#define __MAPPATH_H_
#include <stdlib.h>

#ifndef MAXPATHLEN
#define MAXPATHLEN 256
#endif

struct mpath
{
 char dospath[MAXPATHLEN];
 char lnxpath[MAXPATHLEN];
 char softremap;
};


class mappath {
protected:
 int count;

public:
 struct mpath **path;

 int addpath(char *_src, char *_dest, char _softremap);
 char *remap(char *_path);
 mappath();
 ~mappath();
};

extern mappath pmapper;

#endif
